SystemOrganization addCategory: #'SCouchDB-ViewServer'!
SystemOrganization addCategory: #'SCouchDB-ViewServer-Tests'!
SystemOrganization addCategory: #'SCouchDB-ViewServer-Exceptions'!

Dictionary subclass: #SCouchDBCache
	instanceVariableNames: 'monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBCache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 11/6/2012 16:25'!
cacheSize
^50! !

!SCouchDBCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 10/30/2012 13:51'!
at: sourceCode
	
	| a |
	monitor critical: [
		a:=super at:sourceCode ifAbsent:[a:=nil].
		monitor signal
		].
	^a
	! !

!SCouchDBCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 10/4/2012 17:43'!
at: sourceCode ifAbsent:aBlock
	
	| a |
	monitor critical: [
		a:=super at:sourceCode ifAbsent:aBlock.
		monitor signal
		].
	^a
	! !

!SCouchDBCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 10/4/2012 17:43'!
at: sourceCode put:aCompiledSourceCode
	
	| a |
	monitor critical: [
		a:=super at:sourceCode put:aCompiledSourceCode.
		monitor signal
		].
	^a
	! !

!SCouchDBCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 10/4/2012 17:43'!
initialize:size
super initialize:size.
monitor:=Monitor new! !

!SCouchDBCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 11/6/2012 16:25'!
manageCacheSize
"removes the elements from 1 to cacheSize/2 if the size is greater than #cacheSize "
monitor critical:[
(super size > self class cacheSize) ifTrue:[
	super keys do:[:aKey|
		super removeKey: aKey.
		(super size < ((self class cacheSize / 2 ))) ifTrue:[
			monitor signal.
			 ^self].
		]
	].
monitor signal.
].

^ self! !

!SCouchDBCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:18'!
removeAll

       monitor critical: [
		super removeAll.
          [monitor signal] on:Error do:[self]  
        ].


! !

JsonObject subclass: #SCouchDBAppWrapper
	instanceVariableNames: 'buf mime render filter validate server buildInReduceFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBAppWrapper class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 15:54'!
on:aViewServer
"We need to know the server instance to send print messages"
| a |
super initialize.
a:=self new.
a server:aViewServer.
^a
! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/10/2012 00:01'!
buildInReduceFunctions
^ buildInReduceFunctions ifNil:[
	buildInReduceFunctions:=Dictionary new.
	buildInReduceFunctions at:'sum' put: self sum.
	buildInReduceFunctions at:'count' put: self count.
	buildInReduceFunctions at:'stats' put: self stats.
	buildInReduceFunctions at:'statistics' put: self stats.
	buildInReduceFunctions at:'min' put: self min.
	buildInReduceFunctions at:'max' put: self max.
	buildInReduceFunctions at:'quartiles' put: self quartiles.
	buildInReduceFunctions
	]
	ifNotNil:[buildInReduceFunctions]! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/6/2012 19:28'!
count
^ [:k :v :rereduce|
	|result|
	result:=0.
	rereduce 
	ifTrue:[
		v do:[:e| 
			result:= result + e.
		]. 
	]
	ifFalse:[
		result := v size.
		].
	result "returns result"
	]

! !

!SCouchDBAppWrapper methodsFor: 'views' stamp: 'JesusMari 12/20/2013 19:23'!
emit:aJsonDoc
buf ifNil:[buf:= Stack new].
buf push:( Array with:aJsonDoc id with: aJsonDoc).
self filter viewEmit:true.

	
! !

!SCouchDBAppWrapper methodsFor: 'views' stamp: 'JesusMari 2/14/2013 11:26'!
emit:aJsonDoc key:aKey
buf ifNil:[buf:= Stack new].
buf push:( Array with:aKey with: aJsonDoc).
self filter viewEmit:true.

	
! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:16'!
enforce:aBlock
^self validate enforce:aBlock! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:12'!
field:aField shouldBe:value
^self validate field:aField shouldBe:value! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:13'!
field:aField shouldNotBe:value
^self validate field:aField shouldNotBe:value! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:49'!
filter
filter ifNil:[
	filter:= SCouchDBFilter on:server.
	].

^ filter! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 5/9/2012 10:47'!
filter: anObject
	filter := anObject! !

!SCouchDBAppWrapper methodsFor: 'render-wrapper' stamp: 'JesusMari 5/6/2012 17:20'!
getRow
 ^ (self render getRow)! !

!SCouchDBAppWrapper methodsFor: 'builders' stamp: 'JesusMari 4/23/2012 18:09'!
htmlCanvas
^WAHtmlCanvas builder! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 9/18/2013 09:46'!
indexers
^self validate indexers! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:13'!
isAdmin
^self validate isAdmin! !

!SCouchDBAppWrapper methodsFor: 'render-wrapper' stamp: 'JesusMari 8/22/2012 20:11'!
lastRow
 ^ (self render lastRow)! !

!SCouchDBAppWrapper methodsFor: 'views' stamp: 'JesusMari 7/29/2012 11:51'!
mapDoc
| arr|
buf ifNil:[^ Stack new].
arr:=buf.
buf :=Stack new.
^arr

	
! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/6/2012 19:43'!
max
^ [:k :v :rereduce|
	|result|
	result:=v at:1.
	v do:[:aval|
		(aval>result) ifTrue:[result:=aval].
	].
	result
]

! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/10/2012 01:12'!
median: v from:a to:b 
|median pos tmp |

pos:=b - a.
pos even
ifTrue:[
	median:= v at:((pos / 2) + a)
	]
ifFalse:[
	tmp:=a + ((pos + 1) / 2) -1.
	pos:=tmp + 1.
	median:=(( v at: tmp)  + (v at: pos)) asFloat  / 2.
	].

^median

! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:50'!
mime
	mime ifNil:[mime:=SCouchDBMime on:server].
	^ mime! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 4/22/2012 18:45'!
mime: anObject
	^ mime := anObject! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/6/2012 19:43'!
min
^ [:k :v :rereduce|
	|result|
	result:=v at:1.
	v do:[:aval|
		(aval< result) ifTrue:[result:=aval].
	].
	result
]

! !

!SCouchDBAppWrapper methodsFor: 'mime-wrapper' stamp: 'JesusMari 5/6/2012 17:21'!
provides:mimeKey with:aBlock

self mime provides:mimeKey aBlock:aBlock! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/10/2012 00:50'!
quartiles
^ [:k :v :rereduce|
	|result ov m q1 q3|
	
	rereduce 
	ifTrue:[
		ov= SortedCollection new.
		v do:[:e| 
			ov join: (e at:'ov').
		]. 
		m:=self median:ov from:1 to: ov size.
		q1:= self median: ov from: 1 to: (ov size /2) asInteger .
		q3:= self median: ov from: ((ov size / 2) asInteger +1) to: ov size.
		result:= JsonObject fromAssociations: {
						'ov'-> ov.
						'm'-> m.
						'q1'-> q1.
						'q3' -> q3
					} 
		
	]
	ifFalse:[
		ov:=(SortedCollection newFrom:v) reSort.
		m:=self median:ov from:1 to: ov size.
		q1:= self median: ov from: 1 to: (ov size /2) asInteger .
		q3:= self median: ov from: ((ov size / 2) asInteger +1) to: ov size.
		result:= JsonObject fromAssociations: {
						'ov'-> ov.
						'm'-> m.
						'q1'-> q1.
						'q3' -> q3
					} 
		].
	result "returns result"
	]

! !

!SCouchDBAppWrapper methodsFor: 'render-wrapper' stamp: 'JesusMari 7/10/2012 19:38'!
redirectTo: anUrl

| s |

s:=JsonObject new.
s code:302.
s body:'See other'.
s headers: (JsonObject new Location:anUrl;yourself).
^s.
! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:51'!
render
	render ifNil:[
		render:=SCouchDBRender on:server.
		].
	^ render! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 5/1/2012 17:56'!
render: anObject
	render := anObject! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:14'!
required:aField
^self validate required:aField! !

!SCouchDBAppWrapper methodsFor: 'render-wrapper' stamp: 'JesusMari 5/2/2012 09:56'!
send:aBlock
 ^ render send:aBlock! !

!SCouchDBAppWrapper methodsFor: 'render-wrapper' stamp: 'JesusMari 3/15/2013 10:20'!
sendOnCanvas:aBlock
self deprecated: 'Use MuSTemplate Class'.
 ^ render sendOnCanvas:aBlock! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:46'!
server
	^ server! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:46'!
server: anObject
	server := anObject! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/26/2012 16:51'!
stats

^ [:k :v :rereduce|
	|avg min max sum  count sqSum stdDev variance result|

	avg:=0.min:=0.max:=0.sum:=0.count:=0.stdDev:=0.sqSum:=0.variance:=0.

	rereduce 
	ifTrue:[
		min:= (v at:1) min asFloat .
		max:= (v at:1) max asFloat.
		v do:[:e| 
			(e min asFloat < min) ifTrue:[min:=e min asFloat].
			(e max asFloat > max) ifTrue:[max:=e max asFloat].
			sum:= sum + e sum asFloat.
			sqSum:= sqSum+ e sumSqr asFloat .
			count:= count + e count
		].
		avg := (sum / count) asFloat.
		variance:=(((sqSum ) - (sum*sum/count )) / (count -1) ).
		stdDev :=variance sqrt.
		result :=JsonObject fromAssociations: {
							'min'-> min.
							'max'-> max.
							'avg'-> avg.
							'sum'-> sum.
							'count'-> count.
							'variance'->variance.
							'stdDev'->stdDev.
							'sumSqr'->sqSum
							}.
	]
	ifFalse:[
		min:= (v at:1) asFloat.
		max:= (v at:1) asFloat.
		sum:= 0.
		count:= v size.
		v do:[:e| 
			(e asFloat < min) ifTrue:[min:=e asFloat].
			(e asFloat > max) ifTrue:[max:=e asFloat].
			sum:= sum + e asFloat.
			sqSum:= sqSum+ ((e asFloat )* (e asFloat))
		]. 
		avg :=( sum / count) asFloat.
		variance:=(((sqSum ) - (sum*sum/count )) / (count -1) ).
		stdDev :=variance sqrt.
		result :=JsonObject fromAssociations: {
							'min'-> min.
							'max'-> max.
							'avg'-> avg.
							'sum'-> sum.
							'count'-> count.
							'variance'->variance.
							'stdDev'->stdDev.
							'sumSqr'->sqSum
							}.
		].
	]
! !

!SCouchDBAppWrapper methodsFor: 'render-wrapper' stamp: 'JesusMari 11/4/2012 13:26'!
stopSendingRows
"Still not working, Why?"
| s |
self halt.
s:=JsonObject new.
s at:'stop' put:true.
^s! !

!SCouchDBAppWrapper methodsFor: 'build-in-reduceFunctions' stamp: 'JesusMari 8/5/2012 10:10'!
sum
^ [:k :v :rereduce|
	|result|
	result:=0.
	v do:[:aval|
		result:=result + aval
	].
	result
]

! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:15'!
unchanged:aField
^self validate unchanged:aField! !

!SCouchDBAppWrapper methodsFor: 'validate-wrapper' stamp: 'JesusMari 8/22/2012 20:15'!
userIs:aRol
^self validate userIs:aRol! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:51'!
validate
validate ifNil:[validate:=SCouchDBValidate on:server].
	^ validate! !

!SCouchDBAppWrapper methodsFor: 'accessing' stamp: 'JesusMari 5/9/2012 20:44'!
validate: anObject
	validate := anObject! !

!SCouchDBAppWrapper methodsFor: 'builders' stamp: 'JesusMari 4/23/2012 18:10'!
xmlCanvas
^WAXmlCanvas builder! !

JsonObject subclass: #SCouchDBMime
	instanceVariableNames: 'mimeFuns providesUsed responseContentType mimeDic mimeParser server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBMime class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 15:54'!
on:aViewServer
"We need to know the server instance to send print messages"
| a |
super initialize.
a:=self new.
a server:aViewServer.
^a
! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/22/2012 17:57'!
atValue:mime
^mimeDic at:mime! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/4/2012 16:58'!
initialize:size
super initialize:size.
providesUsed:=false.
mimeFuns:=OrderedCollection new.
mimeDic:=JsonObject new.
mimeParser:=SCouchDBMimeParser new.
self registerType:'all' type:'*/*'.
self registerType:'text' type:'text/plain; charset=utf-8' type:'txt'.
self registerType:'html' type:'text/html; charset=utf-8'.
self registerType:'xhtml' type:'application/xhtml;+xml' type:'xhtml'.
self registerType:'xml' type:'application/xml' type:'text/xml' type:'application/x-xml'.
self registerType:'js' type:'text/javascript' type:'application/javascript' type:'application/x-javascript'.
self registerType:'css' type:'text/css'.
self registerType:'ics' type:'text/calendar'.
self registerType:'csv' type:'text/csc'.
self registerType:'rss' type:'application/rss+xml'.
self registerType:'atom' type:'application/atom+xml'.
self registerType:'yaml' type:'application/yaml' type:'text/yaml'.
self registerType:'multipart_form' type:'multipart/form-data'.
self registerType:'url_encoded_form' type:'application/x-www-form-urlencoded'.
self registerType:'json' type:'application/json' type:'text/x-json'.

! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/22/2012 18:34'!
provides:type aBlock:aBlock

providesUsed:=true.
mimeFuns add:(Array with:type with:aBlock)! !

!SCouchDBMime methodsFor: 'accessing' stamp: 'JesusMari 4/22/2012 18:35'!
providesUsed
	^ providesUsed! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/22/2012 17:08'!
registerType:key type:type
self registerType:key type:type type:nil type:nil
! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/22/2012 17:09'!
registerType:key type:type type:type2

self registerType:key type:type type:type2 type:nil

! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/22/2012 17:55'!
registerType:key type:type type:type2 type:type3

type2
ifNil:[
	self at:key put: (Array with:type).
	mimeDic at:type put:key.
	]
ifNotNil:[
	type3
		ifNil:[
			self at:key put: (Array with:type with:type2).
			mimeDic at:type put:key.
			mimeDic at:type2 put:key.
			]
		ifNotNil:[
			self at:key put: (Array with:type with:type2 with:type3).
			mimeDic at:type put:key.
			mimeDic at:type2 put:key.
			mimeDic at:type3 put:key.
			]
	]! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/22/2012 17:56'!
resetProvides
providesUsed:=false.
mimeFuns removeAll.
responseContentType:=nil.! !

!SCouchDBMime methodsFor: 'accessing' stamp: 'JesusMari 5/4/2012 11:28'!
responseContentType
	^ responseContentType! !

!SCouchDBMime methodsFor: 'accessing' stamp: 'JesusMari 5/4/2012 11:28'!
responseContentType: anObject
	^ responseContentType := anObject! !

!SCouchDBMime methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 12:48'!
runProvides:req
| supportedMimes bestFun bestKey accept mimeKey |

supportedMimes:=OrderedCollection new.
bestFun:=nil.
bestKey:=nil.
accept:=(req at:'headers') at:'Accept'.


(req at:'query') isNil ifTrue:[
	(accept isNil )ifTrue:[
		(mimeFuns reverse) do:[:mimeFun|
			mimeKey:=mimeFun first.
			(self at:mimeKey) ifNotNil:[
				supportedMimes add:(self at:mimeKey)
				]
			].
			responseContentType := mimeParser bestMatch:supportedMimes header:accept.
			bestKey:=self atValue: responseContentType.
		]
	ifFalse:[
		bestKey:=(mimeFuns first) first.
		responseContentType:= (self at:bestKey) first
		]
	]

	
ifFalse:[
	bestKey:=(mimeFuns first) first.
	responseContentType:= (self at:bestKey) first.
	((req at:'query') at:'format')
	 ifNotNil:[
		bestKey:=((req at:'query') at:'format').
		responseContentType:= ((self at:bestKey) first).
		]
	].

bestKey ifNotNil:[
	mimeFuns do:[:mimeFun|
		(bestKey = (mimeFun first)) ifTrue:[bestFun:= (mimeFun at:2)].
		]
	].

(bestFun isNil)
ifTrue:[
	server error:(Array with:'error' with:'not_acceptable' with:('Content-type ',accept asString,'/',bestKey asString)) .
	^nil.
	]
ifFalse:[
	^ bestFun.
	]
! !

!SCouchDBMime methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:50'!
server
	^ server! !

!SCouchDBMime methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:50'!
server: anObject
	server := anObject! !

TestCase subclass: #SCouchDBViewServerTests
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer-Tests'!

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 16:39'!
server
a ifNil:[a:=SCouchDBViewServer new.
		a socketStream: (ReadWriteStream on:'').
		a socketStream nextPutAll: '["list_end"]'.
		a socketStream position: 0
		].
^a. ! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 13:08'!
testAddFun

| b |
a:=self server.
a reset.
b:=a readFrom:'["add_fun","[:doc | self\r\t\temit: (doc)\r\t\tkey: nil]"]'.

self assert: ((a parseJsonArray: b)= 'true').
self assert: (a mapFunctions first isKindOf:BlockClosure)! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 12:52'!
testDDocMissingListList

| b |
a:=self server.
a reset.
b:=a readFrom:'["ddoc","_design/musalbums",["lists","albumIndex"],[{"total_rows":2,"update_seq":1867,"offset":0},{"uuid":"84aa61e42921b91eb8f898f320002ce8","id":null,"form":{},"requested_path":["albums","_design","musalbums","_list","albumIndex","albums"],"headers":{"Connection":"keep-alive","Host":"127.0.0.1:5984","If-None-Match":"\"6TSVEURSXGOTUO3Q6U5W43XH2\"","User-Agent":"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.172 Safari/537.22","Cache-Control":"max-age=0","Accept-Encoding":"gzip,deflate,sdch","Accept-Language":"es-ES,es;q=0.8","Accept":"text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8","Accept-Charset":"ISO-8859-1,utf-8;q=0.7,*;q=0.3"},"secObj":{"members":{"names":[],"roles":[]},"admins":{"names":["jmari","admin"],"roles":["albums-user"]}},"path":["albums","_design","musalbums","_list","albumIndex","albums"],"cookie":{},"raw_path":"/albums/_design/musalbums/_list/albumIndex/albums","userCtx":{"name":null,"roles":[],"db":"albums"},"method":"GET","info":{"doc_del_count":106,"instance_start_time":"1363667149974990","doc_count":4,"disk_size":408522858,"purge_seq":0,"data_size":1670972,"db_name":"albums","disk_format_version":6,"committed_update_seq":1867,"compact_running":false,"update_seq":1867},"body":"undefined","query":{},"peer":"127.0.0.1"}]]'.


self assert: ((a parseJsonArray: b) ='["error","not_found","missing :lists on Design doc_design/musalbums"]').
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 17:03'!
testDDocNew

| b |
a:=self server. 
b:=a readFrom:'["ddoc","new","_design/musalbums",{"views":{"albums":{"map":"[:doc | self\r\t\temit: doc\r\t\tkey: (doc at: ''_id'')]"},"recent-items":{"reduce":"sum","map":"[:doc | self\r\t\temit: (doc at: ''creation_date'')\r\t\tkey: (doc at: ''creation_date'')]"}},"_rev":"266-3783602ebf95e5c752d5e234d2710bdf","_id":"_design/musalbums","lists":{"albumIndex":"[:head :req | self\r\t\tprovides: ''html''\r\t\twith: [:aHead :aReq | \r\t\t\t ''hello list'']]"},"shows":{"album-add":"[:aDoc :req | \r ''hello show'']"},"_attachments":{"javascript/images/icons-18-black.png":{"length":1968,"stub":true,"content_type":"image/png","revpos":266,"digest":"md5-JlZ8DjeHZvOLrzS7xzzw3Q=="},"javascript/images/icons-18-white.png":{"length":1988,"stub":true,"content_type":"image/png","revpos":266,"digest":"md5-vMN5e17iZZXekEU4/oTiiQ=="},"javascript/jquery-migrate-1.1.1.js":{"length":16689,"stub":true,"content_type":"application/x-javascript","revpos":266,"digest":"md5-cMbqTWdmgCpVE+AXoE+XVA=="},"javascript/images/ajax-loader.gif":{"length":7825,"stub":true,"content_type":"image/gif","revpos":266,"digest":"md5-CKMCj9qR1EP01ekzB8lvzQ=="},"javascript/jquery.mobile.theme-1.3.0.css":{"length":49688,"stub":true,"content_type":"text/css","revpos":266,"digest":"md5-Y2uRZFwFqxyqyThY76AuMQ=="},"javascript/jquery.mobile-1.3.0.js":{"length":355848,"stub":true,"content_type":"application/x-javascript","revpos":266,"digest":"md5-bjKTJm9kXhmpHkFfhBiqSQ=="},"javascript/jquery.mobile.structure-1.3.0.css":{"length":79733,"stub":true,"content_type":"text/css","revpos":266,"digest":"md5-oTMsCSwx89aAqweuhEOh9w=="},"javascript/images/icons-36-black.png":{"length":3859,"stub":true,"content_type":"image/png","revpos":266,"digest":"md5-AmbP70AXMHVm54HYFcoH9A=="},"javascript/jquery.mobile-1.3.0.css":{"length":136008,"stub":true,"content_type":"text/css","revpos":266,"digest":"md5-Q+fn+kVBe4UuMu4Y2NAMBQ=="},"javascript/images/icons-36-white.png":{"length":3861,"stub":true,"content_type":"image/png","revpos":266,"digest":"md5-y9pqDhr95ph1wQT26AnxsQ=="},"javascript/jquery-1.9.1.min.js":{"length":92629,"stub":true,"content_type":"application/x-javascript","revpos":266,"digest":"md5-OXdUuknp4M9OfBkNp43aBQ=="}},"language":"smalltalk"}]'.

self assert: ((a parseJsonArray: b)= 'true').
self assert: (a designDocs isKindOf:SCouchDBCache).
self assert: (a designDocs includesKey: '_design/musalbums')! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 16:53'!
testDDocRunList

| b |
a:=self server.
a reset.
self testDDocNew.
b:=a readFrom:'["ddoc","_design/musalbums",["lists","albumIndex"],[{"total_rows":2,"update_seq":1867,"offset":0},{"uuid":"84aa61e42921b91eb8f898f320002ce8","id":null,"form":{},"requested_path":["albums","_design","musalbums","_list","albumIndex","albums"],"headers":{"Connection":"keep-alive","Host":"127.0.0.1:5984","If-None-Match":"\"6TSVEURSXGOTUO3Q6U5W43XH2\"","User-Agent":"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.172 Safari/537.22","Cache-Control":"max-age=0","Accept-Encoding":"gzip,deflate,sdch","Accept-Language":"es-ES,es;q=0.8","Accept":"text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8","Accept-Charset":"ISO-8859-1,utf-8;q=0.7,*;q=0.3"},"secObj":{"members":{"names":[],"roles":[]},"admins":{"names":["jmari","admin"],"roles":["albums-user"]}},"path":["albums","_design","musalbums","_list","albumIndex","albums"],"cookie":{},"raw_path":"/albums/_design/musalbums/_list/albumIndex/albums","userCtx":{"name":null,"roles":[],"db":"albums"},"method":"GET","info":{"doc_del_count":106,"instance_start_time":"1363667149974990","doc_count":4,"disk_size":408522858,"purge_seq":0,"data_size":1670972,"db_name":"albums","disk_format_version":6,"committed_update_seq":1867,"compact_running":false,"update_seq":1867},"body":"undefined","query":{},"peer":"127.0.0.1"}]]'.

"we do not create the socket then we can not get nextRow"
self assert: ((a parseJsonArray: b;lastPrinted)='["end",["hello list"]]').
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 17:04'!
testDDocRunShow

| b |
a:=self server.
a reset.
self testDDocNew.
b:=a readFrom: '["ddoc","_design/musalbums",["shows","album-add"],[{"_rev":"1-f4cd6fbaa38f0e3fe2bf867c6ef91a2a","artist":"Mark Knopfler","_id":"31f9c19475a9950275cbfcd76506d88a","user":"jmari","_revisions":{"start":1,"ids":["f4cd6fbaa38f0e3fe2bf867c6ef91a2a"]},"album":"Get Lucky","description":" sixth solo album released on 14 September 2009"},{"uuid":"19c5956567607e2f00a820339c000bfc","id":"31f9c19475a9950275cbfcd76506d88a","form":{},"requested_path":["albums","_design","musalbums","_show","album","31f9c19475a9950275cbfcd76506d88a"],"headers":{"Host":"127.0.0.1:5984","Referer":"http://127.0.0.1:5984/albums/_design/musalbums/_list/albumIndex/albums","X-Requested-With":"XMLHttpRequest","User-Agent":"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.172 Safari/537.22","Accept-Encoding":"gzip,deflate,sdch","Connection":"keep-alive","Accept-Language":"es-ES,es;q=0.8","Accept":"text/html, */*; q=0.01","Accept-Charset":"ISO-8859-1,utf-8;q=0.7,*;q=0.3"},"secObj":{"members":{"names":[],"roles":[]},"admins":{"names":["jmari","admin"],"roles":["albums-user"]}},"path":["albums","_design","musalbums","_show","album","31f9c19475a9950275cbfcd76506d88a"],"cookie":{},"raw_path":"/albums/_design/musalbums/_show/album/31f9c19475a9950275cbfcd76506d88a","userCtx":{"name":null,"roles":[],"db":"albums"},"method":"GET","info":{"doc_del_count":106,"instance_start_time":"1363794928956730","doc_count":4,"disk_size":409067626,"purge_seq":0,"data_size":1671020,"db_name":"albums","disk_format_version":6,"committed_update_seq":1868,"compact_running":false,"update_seq":1868},"body":"undefined","query":{},"peer":"127.0.0.1"}]]'.


"we do not create the socket then we can not get nextRow"
self assert: ((a parseJsonArray: b;lastPrinted)='["resp",{"body":"hello show"}]').
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 13:35'!
testLog

| b s|

a:=self server.
b:=a readFrom:'["log", "A kuku!!"]'.

self assert: ((a parseJsonArray: b) isNil)
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 13:24'!
testMapDoc

| b s|
a:=self server.
a reset.
self testAddFun.
b:=a readFrom:'["map_doc", {"_id":"8877AFF9789988EE","_rev":"3-235256484","name":"John Smith","score": 60}]'.
s:= ReadStream on:(a parseJsonArray: b).
"[[[null, {'_id':'8877AFF9789988EE'...}]]]"
self assert: (((((Json readFrom:s) at:1 ) at:1) at:2) id ='8877AFF9789988EE').
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 13:30'!
testReReduce

| b s|

self testReduce.
b:=a readFrom:'["rereduce",["sum"],[33,55,66]]'.

self assert: ((a parseJsonArray: b) = '[true,[154]]')
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 13:28'!
testReduce

| b s|

self testMapDoc.
b:=a readFrom:'["reduce",["sum"],[[[1,"699b524273605d5d3e9d4fd0ff2cb272"],10],[[2,"c081d0f69c13d2ce2050d684c7ba2843"],20],[[null,"foobar"],3]]]\n'.

self assert: ((a parseJsonArray: b) = '[true,[33]]')
! !

!SCouchDBViewServerTests methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 12:20'!
testReset

| a b |
a:=SCouchDBViewServer new. 
b:=a readFrom:'["reset",{"timeout":5000,"reduce_limit":true}]'.

self assert: ((a parseJsonArray: b)= 'true').
self assert: (a mapFunctions isNil)! !

Error subclass: #ForbiddenException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer-Exceptions'!

Error subclass: #UnauthorizedException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer-Exceptions'!

Object subclass: #SCouchDBFilter
	instanceVariableNames: 'server viewEmit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBFilter class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 15:54'!
on:aViewServer
"We need to know the server instance to send print messages"
| a |
super initialize.
a:=self new.
a server:aViewServer.
^a
! !

!SCouchDBFilter methodsFor: 'runner' stamp: 'JesusMari 7/29/2012 18:01'!
respond:aJsonObj
"test function"
server debug: ('[SCouchDFilter] respond: ', aJsonObj asString).
server println:(Json render:aJsonObj)! !

!SCouchDBFilter methodsFor: 'runner' stamp: 'JesusMari 5/10/2012 11:43'!
runFilter:fun ddoc:ddoc args:args
|results docs req |
results:= Stack new.
docs:=(args at:1).
req:=(args at:2).
docs do:[:aDoc|
	results push:( fun valueWithEnoughArguments:(Array 
													with:aDoc
													with: req) )
	].
self respond:(Array with:true with:results)
! !

!SCouchDBFilter methodsFor: 'runner' stamp: 'JesusMari 8/24/2012 11:34'!
runFilterView:fun ddoc:ddoc args:args
"recompile"
|results source docs |
results:= Stack new.

docs:=args at:1.

docs do:[:doc|
	viewEmit:=false.
	fun valueWithEnoughArguments:args.
	results push:(self viewEmit).
	self viewEmit:false
	].
self respond:(Array with:true with:results)
! !

!SCouchDBFilter methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:46'!
server
	^ server! !

!SCouchDBFilter methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:46'!
server: anObject
	server := anObject! !

!SCouchDBFilter methodsFor: 'accessing' stamp: 'JesusMari 8/24/2012 11:34'!
viewEmit
	^ viewEmit! !

!SCouchDBFilter methodsFor: 'accessing' stamp: 'JesusMari 8/24/2012 11:34'!
viewEmit: anObject
	viewEmit := anObject! !

Object subclass: #SCouchDBMimeParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBMimeParser methodsFor: 'public' stamp: 'JesusMari 5/3/2012 09:24'!
bestMatch:supported header:header
|parsedHeader  best besti|

parsedHeader:=self parseRanges:header.

supported do:[:supportedi|
	best ifNil:[
		best:= (self fitnessAndQualityParsed:supportedi ranges:parsedHeader).
		besti:=supportedi].
	
	((best at:1) <  ((self fitnessAndQualityParsed:supportedi ranges:parsedHeader) at:1)) ifTrue:[
			best:= (self fitnessAndQualityParsed:supportedi ranges:parsedHeader).
			besti:=supportedi.
	]
].

^ besti
! !

!SCouchDBMimeParser methodsFor: 'public' stamp: 'JesusMari 5/2/2012 19:20'!
fitnessAndQualityParsed:mimeType ranges:parsedRanges
|bestFitness bestFitQ target targetType targetSubtype targetParams fitness|
bestFitness:=-1.
bestFitQ:=0.
target:= self parseMediaRange:mimeType.
targetType:=(target at:1).
targetSubtype:=(target at:2).
targetParams:=(target at:3).
parsedRanges do:[:parsed|
	|type subtype params|
	type:=(parsed at:1).
	subtype:=(parsed at:2).
	params:=(parsed at:3).
	(((type=targetType) or:[(type='*') or:[targetType='*']]) and:[
		((subtype=targetSubtype) or:[(subtype='*') or:[targetSubtype='*']])])
		 ifTrue:[
			|matchCount|
			matchCount:=0.
			targetParams do:[:param|
					((params at:param ifAbsent:[1])	= (targetParams at:param ifAbsent:[0]))
						ifTrue:[matchCount:=matchCount +1]
				].
			fitness:= ((type=targetType) 
						ifTrue:[100] 
						ifFalse:[0]).
			fitness:= fitness +((subtype=targetSubtype) 
						ifTrue:[10]
						ifFalse:[0]).
			fitness:=fitness + matchCount.
			
			(fitness > bestFitness) ifTrue:[
				bestFitness:=fitness.
				bestFitQ:=(params at:'q')]		
		]	
].
^ (Array with:bestFitness with:(bestFitQ asFloat))! !

!SCouchDBMimeParser methodsFor: 'public' stamp: 'JesusMari 5/2/2012 18:44'!
parseMediaRange:aRange
|q parsedType nq |

parsedType:= (self parseMimeType:aRange).
q:= (parsedType at:3) at:'q' ifAbsent:['1'].
[nq:= q asFloat] on:Error do:[ 
		(parsedType at:3) at:'q' put:'1'.	
		^parsedType
	].
(nq <0 or:[nq>1]) ifTrue:[
		(parsedType at:3) at:'q' put:'1'.	
		].
^parsedType


! !

!SCouchDBMimeParser methodsFor: 'public' stamp: 'JesusMari 5/2/2012 18:31'!
parseMimeType: mimeType
|fullType typeParts params parts|
params:=JsonObject new.
parts:= mimeType subStrings:$;.
parts do:[:aPart|
	|p|
	p:=aPart subStrings:$=.
	((p size )= 2) ifTrue:[
		params at:(self strip: (p at:1)) put:(self strip: (p at:2)).
		]
	].
fullType:= (self strip: (parts at:1)).
fullType='*' ifTrue:[fullType:='*/*'].
typeParts:=fullType subStrings:$/.
^ (Array with: (typeParts at:1) with: (typeParts at:2) with:params)! !

!SCouchDBMimeParser methodsFor: 'private' stamp: 'JesusMari 5/2/2012 18:18'!
parseRanges:ranges
|rangeParts parsedRanges|
parsedRanges:=Stack new.
rangeParts= ranges subStrings:$,.
rangeParts do:[:part|
	parsedRanges push:(self parseMediaRange:part)
	].
^parsedRanges
! !

!SCouchDBMimeParser methodsFor: 'public' stamp: 'JesusMari 5/2/2012 19:25'!
quality:mimeType ranges:ranges
^ (self qualityParsed:mimeType ranges:ranges)! !

!SCouchDBMimeParser methodsFor: 'public' stamp: 'JesusMari 5/2/2012 19:23'!
qualityParsed:mimeType ranges:parsedRanges
^ ((self fitnessAndQualityParsed:mimeType ranges:parsedRanges) at:2)! !

!SCouchDBMimeParser methodsFor: 'private' stamp: 'JesusMari 5/2/2012 18:11'!
strip:aMimeHeader
^aMimeHeader decodeMimeHeader! !

Object subclass: #SCouchDBRender
	instanceVariableNames: 'chunks startResp mime lastRow gotRow html xml server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBRender class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 15:53'!
on:aViewServer
"We need to know the server instance to send print messages"
| a |
super initialize.
a:=self new.
a server:aViewServer.
^a
! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 5/4/2012 11:49'!
applyContentType:resp mime:responseContentType
resp at:'headers' ifAbsent:[resp at:'headers' put:(JsonObject new)].

responseContentType ifNotNil:[
	(resp at:'headers') at:'Content-Type' put: responseContentType.
	].
^ resp! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 5/1/2012 17:51'!
blowChunks
self blowChunks:nil
! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 7/5/2012 18:22'!
blowChunks:label
label 
ifNil:[
	self respond: (Array with:'chunks' with:chunks)
	] 
ifNotNil:[
	self respond: (Array with:label asString with:chunks)
	].
chunks isEmpty ifFalse: [chunks pop]
! !

!SCouchDBRender methodsFor: 'public' stamp: 'JesusMari 11/4/2012 10:19'!
getRow
| json |
lastRow ifTrue:[^nil].
gotRow 
ifFalse:[
		gotRow:=true.
		self sendStart.
		]
ifTrue:[
		self blowChunks.
	].

json:=server readJsonFromSocket.
((json at:1) = 'list_end')
ifTrue:[
	lastRow:=true.
	^nil].
((json at:1) = 'list_row') 
ifFalse:[
	server error: (Array
					with:'fatal' 
					with:'list_error'
					with:('not a row ', ( json at:1) asString)).
	^nil
					
	]
ifTrue:[
	^json at:2.
	].


! !

!SCouchDBRender methodsFor: 'accessing' stamp: 'JesusMari 5/1/2012 17:51'!
gotRow
	^ gotRow! !

!SCouchDBRender methodsFor: 'accessing' stamp: 'JesusMari 5/1/2012 17:51'!
gotRow: anObject
	gotRow := anObject! !

!SCouchDBRender methodsFor: 'builders' stamp: 'JesusMari 7/26/2012 19:06'!
htmlCanvas
|a|
a:=Smalltalk at:#WAHtmlCanvas ifAbsent:[^nil].
^ a builder! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 5/2/2012 09:59'!
initialize
super initialize.
chunks:=Stack new.
lastRow:=false.
gotRow:=false.
html:=self htmlCanvas.
xml:=self xmlCanvas.

! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 4/21/2012 18:32'!
isDocRequestPath:info
|path|
path:=info at:path.
^ (path size >5)
! !

!SCouchDBRender methodsFor: 'public' stamp: 'JesusMari 5/1/2012 17:52'!
lastRow
	^ lastRow! !

!SCouchDBRender methodsFor: 'accessing' stamp: 'JesusMari 5/1/2012 17:52'!
lastRow: anObject
	lastRow := anObject! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 5/17/2012 11:20'!
maybeWrapResponse:resp
"todo typeOf must be kindOf? or what"
| type res |
(resp isKindOf:(self class)) ifTrue:[
	res:=JsonObject new.
	res at:'body' put:''.
	^res.
	].
type:= self typeOf:resp.
(type = 'string' or:[type='xml']) 
ifTrue:[
	res:=JsonObject new.
	res at:'body' put:resp.
	^res.
	]
ifFalse:[
	^resp.
	]! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 7/27/2012 21:40'!
resetList
self gotRow:false.
self lastRow:false.
chunks :=Stack new.
startResp:= JsonObject new

! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 7/29/2012 17:53'!
respond:aJsonObj
"test function"
"Transcript show:((Json render:aJsonObj) asString)."
server debug: ('[SCouchDBRender] respond: ', aJsonObj asString).
server println:(Json render:aJsonObj)! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 11/4/2012 13:20'!
runList:fun ddoc:ddoc args:args
|tail head req|
[
	self resetList.
	mime:= ddoc runner mime.
	mime resetProvides.
	head:=args at:1.
	req:=args at:2..

	tail:= fun valueWithEnoughArguments:args.
	(mime providesUsed) ifTrue:[
		tail:= ((mime runProvides:(args at:2)) valueWithEnoughArguments:args ).
		].
	
	(self gotRow) ifFalse:[ddoc runner getRow].
	tail ifNotNil:[
		(tail isKindOf:SCouchDBRender) ifFalse:[chunks push:tail]
		].
	self blowChunks:'end'.
	
	] on:Error do:[:err|
		server debug: ('[SCouchDBRender] runList: ', err asString).
		^ Json render: (Array with:'error' with:'render_error' with:err description)]	.
	^nil.! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 11/5/2012 15:22'!
runShow:fun ddoc:ddoc args:args
|resp providedResp type req b |
[
	
	self resetList.
	mime:= ddoc runner mime.
	mime resetProvides.
	resp:= fun valueWithEnoughArguments:args.

	resp ifNil:[resp:=JsonObject new].
	resp:=self maybeWrapResponse:resp.


	"handle list style API"
	(chunks size>0)
	ifTrue:[
		(resp at:'headers') 
		ifNotNil:[
			(resp at:'headers') do:[:header|
				(resp at:'headers') at:header put: (startResp at:header)
				]
			]
		].
	(chunks size > 0)
	ifTrue:[	
		b:= (String new join:chunks).
		resp at:'body' put: ( b,(resp at:'body'))]
	ifFalse:[	
		resp at:'body' put: (resp at:'body')].
	self resetList.
	(mime providesUsed) 
	ifTrue:[
		req:=args at:2.
		providedResp:= ((mime runProvides: req) valueWithEnoughArguments:args).
		providedResp ifNil:[providedResp:=JsonObject new].
		resp at:'body' put:(
			String 
				nextPutAll:(resp at:'body') ;
				nextPutAll: (String join:chunks));
				nextPutAll: (providedResp at:'body').
		resp:= self applyContentType:resp mime: (mime responseContentType).
		self resetList.
		].
	type:= self typeOf:resp.
	(type='object' or:[type='string']) 
	ifTrue:[
		self respond: (Array with:'resp' with:(self maybeWrapResponse:resp)).
		]
	ifFalse:[
		^ Json render:(Array with:'error' with:'render_error' with:'Undefined response from show function').
		]
	] on:Error do:[:err|
		server debug: ('[SCouchDBRender] runShow: ', err asString).
		^ Json render:(Array with:'error' with:'render_error' with:err description)]	.
	^nil
	
	! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 11/5/2012 15:31'!
runUpdate:fun ddoc:ddoc args:args
|method result doc resp type |
[
	method:=(args at:2) method.
	"for analytics logging applications you might want to remove the next line"
	"(method = 'GET') ifTrue:[^ Json render: (Array with:'error' with:'method not allowed' with:'Update method do not allow GET')]."
	result := fun valueWithEnoughArguments:args.
	doc := (result at:1).
	resp := (result at:2).
	type:= self typeOf:resp.
	(type='string' or:[ type= 'object'])
	 ifTrue:[
		self respond: (Array 
			with:'up' 
			with:doc 
			with: ( self maybeWrapResponse:resp))
	]
	ifFalse:[
		^ Json render:(Array with:'error' with:'render_error' with:'Undefined response from update function')
	]
] on:Error do:[:err|
	server debug: ('[SCouchDBRender] runUpdate: ', err asString).
	^ Json render:(Array with:'error' with:'render_error' with:err description)
]! !

!SCouchDBRender methodsFor: 'public' stamp: 'JesusMari 7/14/2012 09:11'!
send: chunk
"pushes a chunk, it will be sended each time you get a row with getRow or al the end of the List blok execution in #runList"
chunks push: chunk asString! !

!SCouchDBRender methodsFor: 'public' stamp: 'JesusMari 7/5/2012 17:22'!
sendOnCanvas: aBlock
|chunk|
chunk:= html render:aBlock.
chunks push: chunk asString! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 5/4/2012 13:16'!
sendStart
	startResp:= self applyContentType: startResp mime: (mime responseContentType).

	self respond:(Array 
		with: 'start'
		with: chunks
		with: startResp).
	chunks:= Stack new.
	startResp:= JsonObject new
		! !

!SCouchDBRender methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:47'!
server
	^ server! !

!SCouchDBRender methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:47'!
server: anObject
	server := anObject! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 4/21/2012 17:05'!
start
	startResp:=JsonObject new! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 4/21/2012 17:05'!
start: resp
	startResp:=resp! !

!SCouchDBRender methodsFor: 'runner' stamp: 'JesusMari 5/4/2012 16:32'!
typeOf:value
(value isKindOf: JsonObject )ifTrue:[^'object'].
(value isKindOf: Json) ifTrue:[^'array'].
(value isKindOf: String) ifTrue:[^'string'].
^nil
! !

!SCouchDBRender methodsFor: 'builders' stamp: 'JesusMari 7/26/2012 19:07'!
xmlCanvas
|a|
a:=Smalltalk at:#WAXmlCanvas ifAbsent:[^nil].
^ a builder! !

Object subclass: #SCouchDBValidate
	instanceVariableNames: 'args server indexers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

!SCouchDBValidate class methodsFor: 'initialize-release' stamp: 'JesusMari 7/17/2012 15:53'!
on:aViewServer
"We need to know the server instance to send print messages"
| a |
super initialize.
a:=self new.
a server:aViewServer.
^a
! !

!SCouchDBValidate methodsFor: 'accessing' stamp: 'JesusMari 6/26/2012 11:25'!
args
	^ args! !

!SCouchDBValidate methodsFor: 'accessing' stamp: 'JesusMari 6/26/2012 11:25'!
args: anObject
	args := anObject! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 7/16/2012 16:09'!
enforce:aBlock
| ex |
( aBlock value) ifFalse:[ 
	ex:=ForbiddenException new.
	ex messageText:( aBlock asString , ' is not true').
	ex signal]! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 6/27/2012 13:33'!
field:aField shouldBe:value
"checks if a field is  'value' "
| d ex aNewDoc|
aNewDoc:=args at:1.
aNewDoc at:aField ifAbsent:[^ self].
((aNewDoc at:aField) = value) ifTrue:[ 
	ex:=ForbiddenException new.
	ex messageText:( 'Field ',aField,' must be: ',value).
	ex signal]


! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 6/27/2012 13:33'!
field:aField shouldNotBe:value
"checks if a field is not 'value' "
| d ex aNewDoc|
aNewDoc:=args at:1.
aNewDoc at:aField ifAbsent:[^ self].
((aNewDoc at:aField) = value) ifFalse:[ 
	ex:=ForbiddenException new.
	ex messageText:( 'Field ',aField,' must be: ',value).
	ex signal]


! !

!SCouchDBValidate methodsFor: 'accessing' stamp: 'JesusMari 9/18/2013 09:49'!
indexers
^ indexers ifNil:[indexers:= JsonObject new ]! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 6/27/2012 15:22'!
isAdmin
"checks if you are admin "
| roles |

roles:= (args at:3) at:'roles' ifAbsent:[^false].
roles do:[:aRol|
	aRol='_admin' ifTrue:[^true]
	].
^false.


! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 6/27/2012 13:38'!
required:aField
"checks if a field exists and is not nil"
| ex aDoc|
aDoc:=args at:1.
( aDoc includesKey: aField) 
ifFalse:[ 
	ex:=ForbiddenException new.
	ex messageText:( aDoc asString , ' requires the field: ', aField asString).
	ex signal]
ifTrue:[ 
	(aDoc at:aField) ifNil:[
	ex:=ForbiddenException new.
	ex messageText:( aDoc asString , ' requires the field: ', aField asString).
	ex signal]]! !

!SCouchDBValidate methodsFor: 'runner' stamp: 'JesusMari 1/6/2013 19:10'!
runValidate:fun ddoc:ddoc args:vargs

[[
		fun valueWithEnoughArguments:vargs.  
 ^'1'.
] on: ForbiddenException do:[:ex|
server debug: ('[SCouchDBValidate] runValidate ', ex asString).
^ Json render: (Array with:'error'
		with:'Assertion_Exception'
		with:ex description).

]]on: Error do:[:err|
server debug: ('[SCouchDBValidate] runValidate: ', err asString).
^ Json render:(Array with:'error'
		with:'unnamed_error'
		with:err description).

]

	
	! !

!SCouchDBValidate methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:47'!
server
	^ server! !

!SCouchDBValidate methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:47'!
server: anObject
	server := anObject! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 6/27/2012 17:59'!
unchanged:aField
"aField can not change if it changes an Exception will be rised"
| ex aDoc anOldDoc |

aDoc:=args at:1.
anOldDoc:=args at:2.
anOldDoc ifNil:[^self].
(( aDoc at: aField) = (anOldDoc at:aField)) ifFalse:[ 
	ex:=ForbiddenException new.
	ex messageText:( aDoc asString , ' Field can not be changed: ', aField asString).
	ex signal]! !

!SCouchDBValidate methodsFor: 'public' stamp: 'JesusMari 6/27/2012 18:00'!
userIs:aRol
"true if a user has aRol"
| roles |

roles:= (args at:3) at:'roles' ifAbsent:[^false].
roles do:[:anotherRol|
	anotherRol= aRol ifTrue:[^true]
	].
^false.


! !

Object subclass: #SCouchDBViewServer
	instanceVariableNames: 'lib exit sourceArray sourceCollection debug session port ip socketStream aServer socket exitLock funs runner designDocs lastPrinted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-ViewServer'!

SCouchDBViewServer class
	instanceVariableNames: 'servers'!

SCouchDBViewServer class
	instanceVariableNames: 'servers'!

!SCouchDBViewServer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 11:51'!
debugOff
	servers keys do:[:aPort|
		(servers at:aPort ) debugOff.
		]! !

!SCouchDBViewServer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 11:52'!
debugOn
	servers keys do:[:aPort|
		(servers at:aPort ) debugOn.
		]
 ! !

!SCouchDBViewServer class methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 15:50'!
servers
^servers ! !

!SCouchDBViewServer class methodsFor: 'instance creation' stamp: 'JesusMari 7/17/2012 12:22'!
start
	self startOn:8181
 
	

! !

!SCouchDBViewServer class methodsFor: 'instance creation' stamp: 'JesusMari 10/30/2012 18:19'!
start: anIPAdress on:aPort
	|aServer|
	servers ifNil:[servers:= Dictionary new].
	aServer:=SCouchDBViewServer new.
	aServer listenerAddress: anIPAdress.
	aServer startOn:aPort.
	servers at:aPort put:aServer
 
	

! !

!SCouchDBViewServer class methodsFor: 'instance creation' stamp: 'JesusMari 9/23/2013 09:47'!
startOn:aPort
	|aServer|
	servers ifNil:[servers:= Dictionary new].
	aServer:=SCouchDBViewServer new.
	(aPort = #stdio) ifTrue:[aServer startOnStandardIO ]
					ifFalse:[aServer startOn:aPort].
	servers at:aPort put:aServer
 
	

! !

!SCouchDBViewServer class methodsFor: 'instance creation' stamp: 'JesusMari 7/17/2012 13:20'!
stop
	self stop:8181
 	
	

! !

!SCouchDBViewServer class methodsFor: 'instance creation' stamp: 'JesusMari 7/17/2012 13:19'!
stop:aPort
	| s |
	s:=servers at:aPort ifAbsent:[^ nil].
	s stop.
	servers removeKey: aPort
 	
	

! !

!SCouchDBViewServer class methodsFor: 'instance creation' stamp: 'JesusMari 7/17/2012 13:20'!
stopAll
	servers keys do:[:aPort|
		(servers at:aPort ) stop.
		servers removeKey: aPort
		]
 
	

! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:17'!
aServer
	^ aServer! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 7/17/2012 12:17'!
aServer: anObject
	aServer := anObject! !

!SCouchDBViewServer methodsFor: 'views' stamp: 'JesusMari 11/5/2012 15:06'!
compileMapFunction: aMethodSource 

[
		funs ifNil:[ funs:=OrderedCollection new].
		funs add: (Compiler evaluate:aMethodSource for: self runner logged:false ).
		^'true'.	

] on:Error do:
[:err|
	^Json
		render: (Array
				with: 'error'
				with: 'Compilation error: ', err description ,'::', err messageText 
				with: 'function :'
					,aMethodSource)
]! !

!SCouchDBViewServer methodsFor: 'design-docs' stamp: 'JesusMari 11/5/2012 15:49'!
ddoc: jArg 
	| cmd ddocId app funPath funArgs ddoc fun validateDocUpdate |

	cmd := jArg at: 2.
	cmd = 'new'
		ifTrue: [ddocId := jArg at: 3.
			app:= self designDocs at:ddocId.
			(app) 
			ifNil:[
				app := SCouchDBApp fromDictionary:(jArg at: 4) on:self.
				self designDocs at: ddocId put: app.
				]
			ifNotNil:[app server:self].
			self debug: '[ViewServer-DDoc-New]:  ' , (Json render: (self designDocs at: ddocId) language).
			^ 'true'].
	ddocId := cmd.
	[ddoc := self designDocs at: ddocId]
		on: Exception
		do: [self debug: '[ViewServer-DDoc-Command-error]: '
							, (Json render: self designDocs).
			^ Json
				render: (Array
						with: 'fatal'
						with: 'query_protocol_error'
						with: 'uncached design doc:' , ddocId)].
	funPath := jArg at: 3.
	cmd := funPath at: 1.
	funArgs := jArg at: 4.
	validateDocUpdate:= ((funPath at: 1)='validate_doc_update').
	[fun := ddoc at: (funPath at: 1)]
		on: Error
		do: [self debug: '[ViewServer-DDoc-Command-error]: error missing'	, (Json render: funPath).
			^ Json
				render: (Array
						with: 'error'
						with: 'not_found'
						with: 'missing :'
								, (funPath at: 1) , ' on Design doc' , ddocId)].
	validateDocUpdate ifTrue:[
		^ self
		ddocCommand: cmd
		function: fun
		dDoc: ddoc
		fwithArguments: funArgs	
		funcName:(funPath at: 1)
		].
	
	[fun:=fun at: (funPath at: 2)]
		on: Error
		do: [self debug: '[ViewServer-DDoc-Command-error]: error missing'	, (Json
									render: (funPath at: 2)).
			^ Json
				render: (Array
						with: 'error'
						with: 'not_found'
						with: 'missing :'
								, (funPath at: 2) , ' on Design doc' , ddocId)].
	fun ifNil: [^ Json
				render: (Array
						with: 'error'
						with: 'not_found'
						with: 'missing :'
								, (funPath at: 2) , ' on Design doc' , ddocId)].
							
	^ self
		ddocCommand: cmd
		function: fun
		dDoc: ddoc
		fwithArguments: funArgs
		funcName:(funPath at: 2)! !

!SCouchDBViewServer methodsFor: 'design-docs' stamp: 'JesusMari 11/5/2012 16:15'!
ddocCommand: cmd function: fun dDoc: ddoc fwithArguments: funArgs funcName: funcName
|commands function req rowInfo |
commands:= #('lists' 'shows' 'filters' 'views' 'updates' 'validate_doc_update').

(cmd='lists') 
ifTrue:[
		[
			function:= self evaluate:fun for:ddoc logged:false.

			ddoc lists at:funcName put:function.
			^ddoc render runList:function ddoc:ddoc args:funArgs
		
		] on:Error do:[:err|
			self debug: ('[SCouchDB#ddocCommand] list: ', err asString).
			^Json
				render: (Array
						with: 'error'
						with: 'Runtime/compilation error: ', err description ,'::', err messageText 
						with: 'List function :'
								, fun asString )]
	].


(cmd='shows') 
ifTrue:[

		[
			function:= self evaluate:fun for:ddoc  logged:false.
			ddoc shows at:funcName put:function.
			^ddoc render runShow:function ddoc:ddoc args:funArgs			
		] on:Error do:[:err|
			self debug: ('[SCouchDB#ddocCommand] show: ', err asString).
			^Json
				render: (Array
						with: 'error'
						with: 'Runtime/compilation error'
						with: 'Show function :',err description ,'::', err messageText 
								, fun asString)]
	].
(cmd='updates') 
ifTrue:[
		
		[
			function:= self evaluate:fun for:ddoc logged:false.
			ddoc updates at:funcName put:function.
			^ddoc render runUpdate:function ddoc:ddoc args:funArgs
			
		] on:Error do:[:err|
			self debug: ('[SCouchDB#ddocCommand] update: ', err asString).
			^Json
				render: (Array
						with: 'error'
						with: 'Runtime/compilation error'
						with: 'Update function :',err description ,'::', err messageText 
								, fun asString)]
	].

(cmd='filters') 
ifTrue:[
	
		[
			function:= self evaluate:fun for:ddoc logged:false.
			ddoc filters at:funcName put:function.
			^ddoc filter runFilter:function ddoc:ddoc args:funArgs
			
		] on:Error do:[:err|
			self debug: ('[SCouchDB#ddocCommand] filter: ', err asString).
			^Json
				render: (Array
						with: 'error'
						with: 'Runtime/compilation error'
						with: 'Filter function :',err description ,'::', err messageText 
								, fun asString )]
	].

(cmd='views') 
ifTrue:[
		
		[
			function:= self evaluate:fun for:ddoc logged:false.
			ddoc views at:funcName put:function.
			^ddoc filter runFilterView:function ddoc:ddoc args:funArgs
			
		] on:Error do:[:err|
			self debug: ('[SCouchDB#ddocCommand] view: ', err asString).
			^Json
				render: (Array
						with: 'error'
						with: 'Runtime/compilation error'
						with: 'View_filter function :', err description ,'::', err messageText 
								, fun asString )]
	].

(cmd='validate_doc_update') 
ifTrue:[

		[
			function:= self evaluate:fun for:(ddoc validate) logged:false.
			ddoc validateDocUpdate:function.
			ddoc validate args:funArgs.
			^ddoc validate runValidate:function ddoc:ddoc args:funArgs
			
		] on:Error do:[:err|
			self debug: ('[SCouchDB#ddocCommand] validate: ', err asString).
			^Json
				render: (Array
						with: 'error'
						with: 'Runtime/compilation error'
						with: 'Validate function :', err description ,'::', err messageText 
								, fun asString)]
	]! !

!SCouchDBViewServer methodsFor: 'out-subsystem' stamp: 'JesusMari 1/24/2014 12:37'!
debug:aMessage
|aStream m|
	debug ifFalse: [^self].
	m:= '[', DateAndTime now asString,']' ,  (aMessage truncateTo:256).
	Transcript show:(m ,  String cr).
 	aStream := StandardFileStream new open:'ViewServer-debug.txt' forWrite:true.
	aStream ifNil:[Transcript show:('Unable to write debug info at Resources Folder, check for permissions' ). ^self].
	aStream setToEnd.
	aStream nextPutAll:TimeStamp current asString
		;nextPut:$-
		;nextPutAll:m
		;nextPutAll:String crlf.
	aStream flush.
	aStream close.
	

	

! !

!SCouchDBViewServer methodsFor: 'out-subsystem' stamp: 'JesusMari 7/17/2012 12:18'!
debugAll:aMessage
|aStream m|
	m:= (aMessage).
 	aStream := StandardFileStream new open:'debug.txt' forWrite:true.
	aStream setToEnd.
	aStream nextPutAll:TimeStamp current asString
		;nextPut:$-
		;nextPutAll:m
		;nextPutAll:String crlf.
	aStream flush.
	aStream close.
	

! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 11:52'!
debugOff
debug:=false.! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 11:52'!
debugOn
debug:=true.! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 11/6/2012 16:21'!
designDocs
	designDocs ifNil: [designDocs := SCouchDBCache new].
	^ designDocs! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/20/2012 19:51'!
evaluate:fun for:contextInstance logged:logged
."compiles and caches"

(fun isKindOf:BlockClosure) ifTrue:[^fun].
^Compiler evaluate:fun for: contextInstance logged: logged
	

! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/6/2013 12:57'!
exit
^exit! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/6/2013 12:57'!
exit:aBoolean
exit:=aBoolean! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2013 11:42'!
ftsCommand:aJsonRequestObject
| ddoc indexer searchString response|
"full text search needs an OIndexer"
response:= JsonObject new.
[ddoc:= self designDocs at:('_design/' , (aJsonRequestObject path at:3)).
indexer:=ddoc indexerAt:(aJsonRequestObject path at:4).
searchString:= aJsonRequestObject path at:5.
] on: Exception do:[
	response code:510.
	self println:( Json render: response).
	^self.
	].
response code:200.
response json: (indexer findPhrase:searchString).
self println:( Json render: response)

! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/19/2013 06:21'!
initialize
super initialize.
debug:=false! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 3/20/2013 16:49'!
lastPrinted
	^ lastPrinted! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 3/20/2013 16:49'!
lastPrinted: anObject
	lastPrinted := anObject! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/31/2012 02:22'!
listenerAddress
	ip
	ifNil:[ 	^#[0 0 0 0]]
	ifNotNil:[ 	^ip]	
	! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/30/2012 18:18'!
listenerAddress: address
	ip:=address
	! !

!SCouchDBViewServer methodsFor: 'out-subsystem' stamp: 'JesusMari 7/17/2012 15:50'!
log:aMessage

	self println:(Json render: (Array with:'log' with:aMessage)).
 
	

! !

!SCouchDBViewServer methodsFor: 'views' stamp: 'JesusMari 1/25/2014 00:42'!
mapDoc: aDoc
|resultArray val|
	funs ifNil:[^nil].
	resultArray:= OrderedCollection new.

	funs do:[:method|
		[	method value:aDoc.
			"the method fills the buffer doing emit..."
			resultArray add:(self runner mapDoc).
		] on:Error do:[:err| 
			resultArray add:Array new. 
			self debug:'[ViewServer]-MapDocError: ', (err description, ' in ',method).	
			^'{"error":"', 'MapDoc error","reason":"', err description, '::', err messageText, '"}' , String crlf.							
			].
	].
	^ resultArray 
	

! !

!SCouchDBViewServer methodsFor: 'views' stamp: 'JesusMari 3/19/2013 12:19'!
mapFunctions
^funs! !

!SCouchDBViewServer methodsFor: 'parsing' stamp: 'JesusMari 9/23/2013 12:26'!
parseJsonArray:jsonArray
|command argument result finalArray mfunc keyArray valArray tmpArray tmp2Array reduceFunctions rfunc cf |

(jsonArray isKindOf:Array) ifFalse:[
	"jsonArray is aJSon Object"
	(jsonArray path at:2) = '_fts' ifTrue:[	self ftsCommand:jsonArray].
	^nil].
command:= jsonArray at:1.
self debug:(Json render:jsonArray).
(command='ddoc') 
ifTrue:[
	^ self ddoc:jsonArray.
	].
(command='reset') 
ifTrue:
	[
	self reset.
	^ 'true'.
	].
(command='map_doc') 
ifTrue:
	[	
		2 to:(jsonArray size ) do:[:arg|
			finalArray := self mapDoc:(jsonArray at:arg) .
		].
		^(Json render:finalArray).
	].
(command='add_fun') 
ifTrue:
	[
		argument:=jsonArray at:2.
		mfunc :=self compileMapFunction: (argument trimSpaces).
		^mfunc
	].

((command='reduce') or:[(command='rereduce') ]) 
ifTrue:
	[	
			
		reduceFunctions:=jsonArray at:2.
		keyArray:=OrderedCollection new.
		valArray:=OrderedCollection new.
		finalArray:=OrderedCollection new.
		tmpArray:=(jsonArray at:3).

		tmpArray do:[:aKeyDoc|
			tmp2Array:=aKeyDoc.
			(command='reduce') 
				ifTrue:[
					keyArray add:(tmp2Array at:1).
					valArray add:(tmp2Array at:2)]
				ifFalse:[
					valArray add:aKeyDoc
					]
				
			
		].
		(command='reduce') ifTrue:[self log:keyArray asString].
	
		reduceFunctions do:[:arFunc|
			finalArray add: (self reduce:arFunc  
				keys:keyArray 
				values:valArray 
				rereduce:(command='rereduce')).
		].

		^(Json render:(Array with:true with: finalArray)).
	].
exit:=true.
^nil! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/30/2012 18:31'!
port
	^ port! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/30/2012 18:31'!
port: anObject
	port := anObject! !

!SCouchDBViewServer methodsFor: 'out-subsystem' stamp: 'JesusMari 9/23/2013 12:58'!
println:aMessage
|responseStream aMess |

self debug:'[ViewServer]-Response: ',aMessage.
"----just for testing package"
self lastPrinted:aMessage.
"-----"
aMess :=aMessage , String crlf.
self session ifNotNil:[
	(self port = #stdio ) ifTrue:[self session nextPutAll: (aMess)]
						ifFalse:[self session sendSomeData: (aMess)].
	].
	
! !

!SCouchDBViewServer methodsFor: 'input-subsystem' stamp: 'JesusMari 7/17/2012 12:19'!
readFrom: aString
	^ Json new readFrom: aString readStream! !

!SCouchDBViewServer methodsFor: 'input-subsystem' stamp: 'JesusMari 1/24/2014 13:23'!
readJsonFrom: aStream	
	| result |

	result := Json readFrom: (SCouchUTF8Stream on: aStream).
	result ifNotNil:[self debug:'[ViewServer]-Read: ', (Json render:result)].
	^result
! !

!SCouchDBViewServer methodsFor: 'socket-subsystem' stamp: 'JesusMari 11/4/2012 13:20'!
readJsonFromSocket
	^self readJsonFrom: self socketStream.! !

!SCouchDBViewServer methodsFor: 'views' stamp: 'JesusMari 8/6/2012 12:19'!
reduce:rFunction  keys:keyArray values:valArray rereduce:aBoolean
| res rfun reduceFunction|

[
	reduceFunction:= rFunction trimSpaces. 
	rfun:=self runner buildInReduceFunctions at: reduceFunction ifAbsent:[
		
		self runner buildInReduceFunctions 
			at: reduceFunction
			put: (Compiler evaluate:reduceFunction for: self runner logged:false ).
		].

	res:= rfun valueWithEnoughArguments:( Array with:keyArray with:valArray with:aBoolean).
	^res
] 
on:Error 
do:[:err| 
	self log:err description.
	^Array with:false with:nil]! !

!SCouchDBViewServer methodsFor: 'views' stamp: 'JesusMari 9/23/2013 12:16'!
reset
	funs:=nil.
	lib:= nil.
	runner:=nil.
	
	

	

	! !

!SCouchDBViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/24/2012 09:30'!
runner
	runner ifNil:[
		runner:=(SCouchDBAppWrapper on:self).
	].
	
	^ runner! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/30/2012 18:32'!
session
	^ session! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/30/2012 18:32'!
session: anObject
	^ session := anObject! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 11/4/2012 10:48'!
socketStream
	^ socketStream! !

!SCouchDBViewServer methodsFor: 'accessing' stamp: 'JesusMari 10/15/2013 13:28'!
socketStream: anObject
	socketStream := anObject.
	! !

!SCouchDBViewServer methodsFor: 'socket-subsystem' stamp: 'JesusMari 11/5/2012 17:56'!
start
"Starts the server and reads the a Json Array from net"
self startOn:8181! !

!SCouchDBViewServer methodsFor: 'socket-subsystem' stamp: 'JesusMari 9/17/2013 18:58'!
startOn:aPort
"Starts the server and reads the a Json Array from net"

self class stop:aPort.
self port: aPort..
self session:nil.
self debugOff.
exit:=false.


aServer:=[
	[
	|  jsonArray msg  |
	[exit] whileFalse:[

			[self session isNil and:[self exit not]] whileTrue:[
				socket:=Socket newTCP. 
				socket listenOn:port backlogSize:50 interface:self listenerAddress.
				self debug: '- Socket created'.
				socket isValid ifFalse: [ self error: 'Cannot listen on port ' , port greaseString ].
				"we need to wait a very high value...serial conection 
				will be up all the time the couchdb is running"
				self session: (socket waitForAcceptFor:604800000 ifTimedOut:[	
						Processor yield.
						self session:nil.
						(Delay forMilliseconds: 10) wait.
						socket destroy.
						])
			].
			self socketStream: (SocketStream on: self session).
			[jsonArray:=self readJsonFrom:socketStream] on:Exception do:[jsonArray:=nil].
			jsonArray isNil 
			ifTrue:[
				[socket closeAndDestroy.
				self socketStream close.
				self session:nil] on:Error do:[nil]
			]
			ifFalse:[	
				[msg:=self parseJsonArray:jsonArray.
				msg ifNotNil:[self println:msg]] on:Error do:[nil].
			] 
		]
	] ensure:
		[
		socket closeAndDestroy.
		self socketStream ifNotNil:[self socketStream close].
		self session ifNotNil:[self session closeAndDestroy].
		self session:nil]
	] forkNamed:('SCouchViewServerOn-' , port asString).

! !

!SCouchDBViewServer methodsFor: 'socket-subsystem' stamp: 'JesusMari 9/23/2013 13:29'!
startOnStandardIO
"Starts the server reading on standard io"

self class stop:#stdio.
self port: #stdio.
self session:nil.
self debugOff.
exit:=false.

aServer:=[
	[|  jsonArray msg  |
	[exit] whileFalse:[	
			self session: StandardFileStream stdout.
			self socketStream: StandardFileStream stdin.				
			[jsonArray:=self readJsonFrom:self socketStream] on:Exception do:[jsonArray:=nil].
			[msg:=self parseJsonArray:jsonArray.
				msg ifNotNil:[self println:msg]] on:Error do:[nil].
			] 
	] ensure:[
		self session:nil]
	] forkNamed:('SCouchViewServerOn-' , port asString).

! !

!SCouchDBViewServer methodsFor: 'socket-subsystem' stamp: 'JesusMari 11/2/2012 17:42'!
stop
self exit:true.
aServer ifNotNil:[
		aServer terminate.
		aServer:=nil
	].! !
